# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import wx
import wx.xrc
import threading
import PGChat
    
class Controller(object):
    def __init__(self, controller):
        import os.path
        self.game_controller = controller
        self.res = wx.xrc.XmlResource(os.path.join('xrc', 'pygrid_server.xrc'))
        self.frame = self.res.LoadDialog(None, 'mainFrame')
        self.frame.Bind(wx.EVT_CLOSE, self.hideWindow)
        
        self.statusField = wx.xrc.XRCCTRL(self.frame, 'statusField')
        wx.xrc.XRCCTRL(self.frame, 'hostButton').Bind(wx.EVT_BUTTON, self.doListen)
        self.listening_socket = None
        self.listening_port = None
        
    def showWindow(self):
        self.frame.Show()
        self.frame.Raise()
        
    def hideWindow(self, event=None):
        if self.listening_socket:
            #print 'cancelling listen'
            self.game_controller.abort_network_listen(self.listening_port)
            self.listening_socket = None
            self.statusField.SetLabel('')
        self.frame.Hide()
        
    def doListen(self, event):
        if self.listening_socket: return
        port = int(wx.xrc.XRCCTRL(self.frame, 'portField').GetValue())
        self.game_controller.network_listen(port)

    def network_listening(self, port, sock):
        self.statusField.SetLabel('Listening on port '+str(port))
        self.listening_socket = sock
        self.listening_port = port
        
    def network_listen_failed(self, port):
        self.statusField.SetLabel('Failed to listen on port '+str(port))
        self.listening_socket = None
        
    def network_connected(self, sock):
        self.statusField.SetLabel('Connected')
        self.listening_socket = None
